### Combine the estimates of log mean ratio and its variance in MeanVars
### with the old data

data(data)
library(splines)

getquants <- function(dsname) {
  load(file.path("Stats",dsname,"Dists.RData"))
  NR <- length(AllDists)
  quants <- data.frame(Q2.5 = numeric(NR),
                       median = numeric(NR),
                       Q97.5 = numeric(NR))
  
  for (i in 1:NR) {
    indx <- c(TRUE,diff(AllDists[[i]][[1]]$Y) > 0)
    spl <- try(interpSpline(AllDists[[i]][[1]]$X[indx],
                        AllDists[[i]][[1]]$Y[indx]))
    if (!inherits(spl,"try-error")) {
      rng <- range(AllDists[[i]][[1]]$X[indx])
      out <- uniroot(function(x)predict(spl,x)[[2]] - 0.025,interval=rng)
      quants[i,"Q2.5"] <- out$root
      out <- uniroot(function(x)predict(spl,x)[[2]] - 0.5,interval=rng)
      quants[i,"median"] <- out$root
      out <- uniroot(function(x)predict(spl,x)[[2]] - 0.975,interval=rng)
      quants[i,"Q97.5"] <- out$root
    }
  }
  quants
}


    
    

mutacute <- mutacute[,c(1:16,24:26)]
load(file.path("Stats","mutacute","MeanVar.RData"))

mutacute$meanlratio1 <- MeanVar[[1]][,1]
mutacute$varlratio1 <- MeanVar[[1]][,2]
mutacute$meanlratio2 <- MeanVar[[2]][,1]
mutacute$varlratio2 <- MeanVar[[2]][,2]
quants <- getquants("mutacute")
mutacute <- cbind(mutacute,quants)

write.table(mutacute,file="mutacute2004-04-08.csv",sep=",",row.names=FALSE)

mutrep <- mutrep[,c(1:14,22:24)]
load(file.path("Stats","mutrep","MeanVar.RData"))

mutrep$meanlratio1 <- MeanVar[[1]][,1]
mutrep$varlratio1 <- MeanVar[[1]][,2]
mutrep$meanlratio2 <- MeanVar[[2]][,1]
mutrep$varlratio2 <- MeanVar[[2]][,2]
quants <- getquants("mutrep")
mutrep <- cbind(mutrep,quants)

write.table(mutrep,file="mutrep2004-04-08.csv",sep=",",row.names=FALSE)

nmrep <- nmrep[,c(1:14,22:25)]
load(file.path("Stats","nmrep","MeanVar.RData"))

nmrep$meanlratio1 <- MeanVar[[1]][,1]
nmrep$varlratio1 <- MeanVar[[1]][,2]
nmrep$meanlratio2 <- MeanVar[[2]][,1]
nmrep$varlratio2 <- MeanVar[[2]][,2]
quants <- getquants("nmrep")
nmrep <- cbind(nmrep,quants)

write.table(nmrep,file="nmrep2004-04-08.csv",sep=",",row.names=FALSE)

lifetime <- lifetime[,c(1:14,22:24)]
load(file.path("Stats","lifetime","MeanVar.RData"))

lifetime$meanlratio1 <- MeanVar[[1]][,1]
lifetime$varlratio1 <- MeanVar[[1]][,2]
lifetime$meanlratio2 <- MeanVar[[2]][,1]
lifetime$varlratio2 <- MeanVar[[2]][,2]
quants <- getquants("lifetime")
lifetime <- cbind(lifetime,quants)

write.table(lifetime,file="lifetime2004-04-08.csv",sep=",",row.names=FALSE)
