data(data)
library(adapt)
library(splines)
istart <- 1

Npoints <- 120000
boundX <- function(X) {
  X$est <- pmin(pmax(X$est,X$low + 10*.Machine$double.eps),
                X$upp - 10*.Machine$double.eps)
  X
}
"%IN%" <- function(x,y) {(x >= y[1]) & (x <= y[2])}

d <- lifetime
NR <- nrow(d)

Lrhopriorsd <- c(3,6)
if (istart == 1) {
  MeanVar <- list(data.frame(Mean=numeric(NR),
                             Var=numeric(NR),
                             MeanPc=numeric(NR),
                             MeanPa=numeric(NR),
                             L025=numeric(NR),
                             Median=numeric(NR),
                             U975=numeric(NR)),
                  data.frame(Mean=numeric(NR),
                             Var=numeric(NR),
                             MeanPc=numeric(NR),
                             MeanPa=numeric(NR),
                             L025=numeric(NR),
                             Median=numeric(NR),
                             U975=numeric(NR)))
  AllDists <- vector("list",NR)
} else {
  load(file.path("Stats","lifetime","Dists.RData"))
  load(file.path("Stats","lifetime","MeanVar.RData"))
}
for (i in istart:nrow(d)){

  cat(paste("\n>>>>>>>>>>>>>>>>>>>>>>>", date(),"Row",i,"\n"))
  print(d[i,c("CNum","CEff","JNum","JEff","JDur","ANum","AEff","ADur")])
  cat("\n")
  Nc <- d$CNum[i]
  nc <- d$CEff[i]
  Nj <- d$JNum[i]
  nj <- d$JEff[i]
  Na <- d$ANum[i]
  na <- d$AEff[i]
  Dur.a <- d$ADur[i]
  Dur.j <- d$JDur[i]
  DistSave <- vector("list",length(Lrhopriorsd))
  for (k in 1:length(Lrhopriorsd)) {
    lrhopriorsd <- Lrhopriorsd[k]
    cat(paste("lrho prior sd is",lrhopriorsd,"\n"))
    lrhomin <- -7*lrhopriorsd
    lrhomax <- 7*lrhopriorsd

    ## full posterior, with lrho transformed by logit 
    TfnFull <- function(x) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- x[3]
      lrho <- log(x[3]/(1 - x[3]))
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                     dbinom(nc,Nc,Pc,log=TRUE) +
                     dbinom(na,Na,Pa,log=TRUE) +
                     dbinom(nj,Nj,Pj,log=TRUE))/
                       (P*(1 - P))
    }
  
    ## Marginal posterior, with lrho transformed by logit 
    TfnMarg <- function(x,lrho) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- (1 + exp(-lrho))^(-1)
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                     dbinom(nc,Nc,Pc,log=TRUE) +
                     dbinom(na,Na,Pa,log=TRUE) +
                     dbinom(nj,Nj,Pj,log=TRUE))/
                       (P*(1 - P))
    }
  
    ## Function for estimating the mean using integration,
    ## with lrho transformed by logit 
    TfnMean <- function(x) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- x[3]
      lrho <- log(x[3]/(1 - x[3]))
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      lrho*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                          dbinom(nc,Nc,Pc,log=TRUE) +
                          dbinom(na,Na,Pa,log=TRUE) +
                          dbinom(nj,Nj,Pj,log=TRUE))/
                            (P*(1 - P))
    }
    TfnMean1 <- function(x) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- x[3]
      lrho <- log(x[3]/(1 - x[3]))
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      Pc*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                        dbinom(nc,Nc,Pc,log=TRUE) +
                        dbinom(na,Na,Pa,log=TRUE) +
                        dbinom(nj,Nj,Pj,log=TRUE))/
                          (P*(1 - P))
    }
    TfnMean2 <- function(x) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- x[3]
      lrho <- log(x[3]/(1 - x[3]))
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      (1-Q)*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                           dbinom(nc,Nc,Pc,log=TRUE) +
                           dbinom(na,Na,Pa,log=TRUE) +
                           dbinom(nj,Nj,Pj,log=TRUE))/
                             (P*(1 - P))
    }
  
    ## Function for estimating the mean using integration,
    ## with lrho transformed by logit 
    TfnVar <- function(x,lrho.mean) {
      Pc <- x[1]
      Q <- x[2]
      ma <- -log(Q)/Dur.a
      P <- x[3]
      lrho <- log(x[3]/(1 - x[3]))
      rho <- exp(lrho)
      Pa <- Pc + (1 - Pc)*(1 - Q)
      Pj <- Pc + (1 - Pc)*(1 - exp(-ma*rho*(Dur.j - Dur.a) - ma*Dur.a))
      (lrho-lrho.mean)^2*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                                        dbinom(nc,Nc,Pc,log=TRUE) +
                                        dbinom(na,Na,Pa,log=TRUE) +
                                        dbinom(nj,Nj,Pj,log=TRUE))/
                                          (P*(1 - P))
    }

    X2 <- list(low=c(0,0,1/(1 + exp(-lrhomin))),
               upp=c(1,1,1/(1 + exp(-lrhomax))))
  
    print(X2)

    cat("\nIntegrating the non-normalized posterior\n")
    ndim <-  3
    tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                 functn=TfnFull, eps=0.0001)
    if (tmp$ifail == 0) {
      Norm2 <- tmp$value
      cat(paste("Norm from Transformed function is",Norm2,"\n"))
    } else {
      Norm2 <- NA
    }
  
    ## Mean value for lrho using transformed function
    tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                 functn=TfnMean,
                 eps=0.0001)
    if (tmp$ifail == 0) {
      lrho.Mean <- tmp$value/Norm2
      cat(paste("Mean of lrho by Transformed function is",lrho.Mean,"\n"))
      MeanVar[[k]][i,"Mean"] <- lrho.Mean
    } 
    ## Mean value for Pc using transformed function
    tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                 functn=TfnMean1,
                 eps=0.0001)
    if (tmp$ifail == 0) {
      lrho.Mean1 <- tmp$value/Norm2
      MeanVar[[k]][i,"MeanPc"] <- lrho.Mean1
      cat(paste("Mean of Pc by Transformed function is",lrho.Mean1,"\n"))
    } 
    ## Mean value for 1-Q using transformed function
    tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                 functn=TfnMean2,
                 eps=0.0001)
    if (tmp$ifail == 0) {
      lrho.Mean2 <- tmp$value/Norm2
      MeanVar[[k]][i,"MeanPa"] <- lrho.Mean2
      cat(paste("Mean of (1-Q) by Transformed function is",lrho.Mean2,"\n"))
    } 

    ## Variance of lrho
    tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                 functn=TfnVar,
                 eps=0.0001,lrho.mean=lrho.Mean)
    if (tmp$ifail == 0) {
      lrho.Var <- tmp$value/Norm2
      cat(paste("Variance of lrho is",lrho.Var,"\n"))
      MeanVar[[k]][i,"Var"] <- lrho.Var
    } 

    ## Calculate the marginal posterior distribution function for lrho.
    ## Start with ratio/10, and work backwards until the mass to the
    ## left is < 0.01, then start stepping to the right, up through 0.99
  
    lrho <- lrho.Mean - 3*sqrt(lrho.Var)
    x.save <- NULL
    mass.save <- NULL
    lbound <- X2$low
    ubound <- X2$upp
    Indx <- length(ubound)
    rcount <- 0
    Failure <- FALSE
    cat("Finding the bottom:\n")
    repeat {
      if (rcount > 10) {
        Failure <- TRUE
        break
      }
      ubound[Indx] <- (1 + exp(-lrho))^(-1)
      out <- try(adapt(ndim=ndim,lower=lbound,upper=ubound,
                       minpts=Npoints,functn=TfnFull,
                       eps=0.0001))
      if (!inherits(out,"try-error") && out$ifail == 0) {
        cat(paste(lrho,"  ",out$value/Norm2,"\n"))
        rcount <- 0
        x.save <- c(x.save,lrho)
        mass.save <- c(mass.save,out$value/Norm2)
        if (out$value/Norm2 < 0.005) {
          lrhomin <- lrho
          break
        }
        lrho <- lrho - log(2)
      } else {
        cat("!!!!!!! failure:\n")
        print(out)
        lrho <- lrho + log(2)
        rcount <- rcount + 1
      }
    }
    ## Now find the top end
    lrho <- lrho.Mean + 3*sqrt(lrho.Var)
    rcount <- 0
    Failure <- FALSE
    cat("Finding the top:\n")
    repeat {
      if (rcount > 10) {
        Failure <- TRUE
        break
      }
      ubound[Indx] <- (1 + exp(-lrho))^(-1)
      out <- try(adapt(ndim=ndim,lower=lbound,upper=ubound,
                       minpts=Npoints,functn=TfnFull,
                       eps=0.0001))
      if (!inherits(out,"try-error") && out$ifail == 0) {
        cat(paste(lrho,"  ",out$value/Norm2,"\n"))
        rcount <- 0
        x.save <- c(x.save,lrho)
        mass.save <- c(mass.save,out$value/Norm2)
        if (out$value/Norm2 > 0.995) {
          lrhomax <- lrho
          break
        }
        lrho <- lrho + log(2)
      } else {
        cat("!!!!!!! failure:\n")
        print(out)
        lrho <- lrho - log(2)
        rcount <- rcount + 1
      }
    }

    rhosteps <- seq(lrhomin,lrhomax,length=11)
    masssteps <- numeric(length(rhosteps))
    
    ## Stepping Up
    if (!Failure) {
      for (kk in 1:length(rhosteps)) {
        lrho <- rhosteps[kk]
        ubound[Indx] <- (1 + exp(-lrho))^(-1)
        out <- try(adapt(ndim=ndim, lower=lbound,upper=ubound,
                         minpts=Npoints,functn=TfnFull,
                         eps=0.0001))
        if (!inherits(out, "try-error") && out$ifail == 0) {
          cat(paste(lrho, "  ",out$value/Norm2,"\n"))
          masssteps[kk] <- out$value/Norm2
        } else {
          cat("!!!!!! failure in stage 2:\n")
          print(out)
        }
      }
    }
    x.save <- c(x.save,rhosteps)
    mass.save <- c(mass.save,masssteps)

    SIndx <- order(x.save)
    x.save <- x.save[SIndx]
    mass.save <- mass.save[SIndx]
    mass.save <- mass.save[!duplicated(x.save)]
    x.save <- x.save[!duplicated(x.save)]
    DistSave[[k]] <- list(X = c(x.save), Y=c(mass.save))
    fspl <- try(interpSpline(x.save,mass.save))
    if (!inherits(fspl,"try-error")) {
      bspl <- try(backSpline(fspl))
    } else {
      bspl <- fspl
    }
    if (!inherits(bspl,"try-error")) {
      qntl <- predict(bspl,c(0.025,0.50,0.975))
      MeanVar[[k]][i,"L025"] <- qntl[[2]][1]
      MeanVar[[k]][i,"Median"] <- qntl[[2]][2]
      MeanVar[[k]][i,"U975"] <- qntl[[2]][3]
    }
   
  }
  AllDists[[i]] <- DistSave
  save("AllDists",file=file.path("Stats","lifetime","Dists.RData"))
  save("MeanVar",file=file.path("Stats","lifetime","MeanVar.RData"))
  gc()
}
