data(data)
library(adapt)
istart <- 1
Npoints <- 120000

boundX <- function(X) {
  X$est <- pmin(pmax(X$est,X$low + 10*.Machine$double.eps),
                X$upp - 10*.Machine$double.eps)
  X
}
"%IN%" <- function(x,y) {(x >= y[1]) & (x <= y[2])}

d <- mutacute


NR <- nrow(d)

Lrhopriorsd <- c(3,9)
if (istart == 1) {
  MeanVar <- list(data.frame(Mean=numeric(NR),
                             Var=numeric(NR),
                             MeanPc=numeric(NR),
                             MeanPa=numeric(NR),
                             L025=numeric(NR),
                             Median=numeric(NR),
                             U975=numeric(NR)),
                  data.frame(Mean=numeric(NR),
                             Var=numeric(NR),
                             MeanPc=numeric(NR),
                             MeanPa=numeric(NR),
                             L025=numeric(NR),
                             Median=numeric(NR),
                             U975=numeric(NR)))
  AllDists <- vector("list",NR)
} else {
  load(file.path("Stats","mutacute","Dists.RData"))
  load(file.path("Stats","mutacute","MeanVar.RData"))
}

for (i in istart:nrow(d)){
  cat(paste("\n>>>>>>>>>>>>>>>>>>>>>>>", date(),"Row",i,"\n"))
  print(d[i,c("CnumJ","CeffJ","CnumA","CeffA","JNum","JEff","ANum","AEff")])
  cat("\n")
  Ncj <- d$CnumJ[i]
  ncj <- d$CeffJ[i]
  Nca <- d$CnumA[i]
  nca <- d$CeffA[i]
  Nj <- d$JNum[i]
  nj <- d$JEff[i]
  Na <- d$ANum[i]
  na <- d$AEff[i]
  DistSave <- vector("list",length(Lrhopriorsd))
  for (k in 1:length(Lrhopriorsd)) {
    lrhopriorsd <- Lrhopriorsd[k]
    cat(paste("lrho prior sd is",lrhopriorsd,"\n"))
    lrhomin <- -7*lrhopriorsd
    lrhomax <- 7*lrhopriorsd
  
    ## full posterior, with lrho transformed by logit 
    TfnFull <- if (d$Flag[i]) {
      function(x) {
        Pcj <- x[1]
        Pca <- x[2]
        Q <- x[3]
        P <- x[4]
        lrho <- log(P/(1 - P))
        rho <- exp(lrho)
        Pj <- Pcj + (1 - Pcj)*(1 - Q^rho)
        Pa <- Pca + (1 - Pca)*(1 - Q)
        ## Priors:
        ## x[1:2]: triangular
        ## x[3]: U(0,1)
        ## x[4]: N(0,3)
        2*(1 - Pcj)*2*(1 - Pca)*
          exp(dnorm(lrho,sd=lrhopriorsd,log=TRUE) + 
              dbinom(nca,Nca,Pca,log=TRUE) +
              dbinom(ncj,Ncj,Pcj,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    } else {
      function(x) {
        Pc <- x[1]
        Q <- x[2]
        P <- x[3]
        lrho <- log(x[3]/(1 - x[3]))
        rho <- exp(lrho)
        Pa <- Pc + (1 - Pc)*(1 - Q)
        Pj <- Pc + (1 - Pc)*(1 - Q^rho)
        2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                       dbinom(nca,Nca,Pc,log=TRUE) +
                       dbinom(na,Na,Pa,log=TRUE) +
                       dbinom(nj,Nj,Pj,log=TRUE))/
                         (P*(1 - P))
      }
    }

    ## Function for estimating the mean using integration
    TfnMean <- if (d$Flag[i]) {
      function(x) {
        Pcj <- x[1]
        Pca <- x[2]
        Q <- x[3]
        P <- x[4]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pj <- Pcj + (1 - Pcj)*(1 - Q^rho)
        Pa <- Pca + (1 - Pca)*(1 - Q)
        ## Priors:
        ## x[1:2]: triangular
        ## x[3]: U(0,1)
        ## x[4]: N(0,3)
        lrho*2*(1 - Pcj)*2*(1 - Pca)*
          exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
              dbinom(nca,Nca,Pca,log=TRUE) +
              dbinom(ncj,Ncj,Pcj,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    } else {
      function(x) {
        Pc <- x[1]
        Q <- x[2]
        P <- x[3]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pa <- Pc + (1 - Pc)*(1 - Q)
        Pj <- Pc + (1 - Pc)*(1 - Q^rho)
        lrho*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                            dbinom(nca,Nca,Pc,log=TRUE) +
                            dbinom(na,Na,Pa,log=TRUE) +
                            dbinom(nj,Nj,Pj,log=TRUE))/
                              (P*(1 - P))
      }
    }
    ## Function for estimating the mean using integration
    TfnMean1 <- if (d$Flag[i]) {
      function(x) {
        Pcj <- x[1]
        Pca <- x[2]
        Q <- x[3]
        P <- x[4]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pj <- Pcj + (1 - Pcj)*(1 - Q^rho)
        Pa <- Pca + (1 - Pca)*(1 - Q)
        ## Priors:
        ## x[1:2]: triangular
        ## x[3]: U(0,1)
        ## x[4]: N(0,3)
        ((Pcj + Pca)/2)*2*(1 - Pcj)*2*(1 - Pca)*
          exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
              dbinom(nca,Nca,Pca,log=TRUE) +
              dbinom(ncj,Ncj,Pcj,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    } else {
      function(x) {
        Pc <- x[1]
        Q <- x[2]
        P <- x[3]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pa <- Pc + (1 - Pc)*(1 - Q)
        Pj <- Pc + (1 - Pc)*(1 - Q^rho)
        Pc*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                          dbinom(nca,Nca,Pc,log=TRUE) +
                          dbinom(na,Na,Pa,log=TRUE) +
                          dbinom(nj,Nj,Pj,log=TRUE))/
                            (P*(1 - P))
      }
    }
    ## Function for estimating the mean using integration
    TfnMean2 <- if (d$Flag[i]) {
      function(x) {
        Pcj <- x[1]
        Pca <- x[2]
        Q <- x[3]
        P <- x[4]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pj <- Pcj + (1 - Pcj)*(1 - Q^rho)
        Pa <- Pca + (1 - Pca)*(1 - Q)
        ## Priors:
        ## x[1:2]: triangular
        ## x[3]: U(0,1)
        ## x[4]: N(0,3)
        (1 - Q)*2*(1 - Pcj)*2*(1 - Pca)*
          exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
              dbinom(nca,Nca,Pca,log=TRUE) +
              dbinom(ncj,Ncj,Pcj,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    } else {
      function(x) {
        Pc <- x[1]
        Q <- x[2]
        P <- x[3]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pa <- Pc + (1 - Pc)*(1 - Q)
        Pj <- Pc + (1 - Pc)*(1 - Q^rho)
        (1 - Q)*2*(1 - Pc)*exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
                               dbinom(nca,Nca,Pc,log=TRUE) +
                               dbinom(na,Na,Pa,log=TRUE) +
                               dbinom(nj,Nj,Pj,log=TRUE))/
                                 (P*(1 - P))
      }
    }
    ## Function for estimating the variance using integration
    TfnVar <- if (d$Flag[i]) {
      function(x,lrho.mean) {
        Pcj <- x[1]
        Pca <- x[2]
        Q <- x[3]
        P <- x[4]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pj <- Pcj + (1 - Pcj)*(1 - Q^rho)
        Pa <- Pca + (1 - Pca)*(1 - Q)
        ## Priors:
        ## x[1:2]: triangular
        ## x[3]: U(0,1)
        ## lrho: N(0,3)
        (lrho-lrho.mean)^2*2*(1 - Pcj)*2*(1 - Pca)*
          exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
              dbinom(nca,Nca,Pca,log=TRUE) +
              dbinom(ncj,Ncj,Pcj,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    } else {
      function(x,lrho.mean) {
        Pc <- x[1]
        Q <- x[2]
        P <- x[3]
        rho <- P/(1 - P)
        lrho <- log(rho)
        Pa <- Pc + (1 - Pc)*(1 - Q)
        Pj <- Pc + (1 - Pc)*(1 - Q^rho)
        (lrho-lrho.mean)^2*2*(1 - Pc)*
          exp(dnorm(lrho,mean=0,sd=lrhopriorsd,log=TRUE) +
              dbinom(nca,Nca,Pc,log=TRUE) +
              dbinom(na,Na,Pa,log=TRUE) +
              dbinom(nj,Nj,Pj,log=TRUE))/
                (P*(1 - P))
      }
    }
      X2 <- list(low=c(0,0,1/(1 + exp(-lrhomin))),
                 upp=c(1,1,1/(1 + exp(-lrhomax))))

      print(X2)
      cat("\nIntegrating the non-normalized posterior\n")
      ndim <- if(d$Flag[i]) 4 else 3
      tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                   functn=TfnFull, eps=0.0001)
      if (tmp$ifail == 0) {
        Norm2 <- tmp$value
        cat(paste("Norm from Transformed function is",Norm2,"\n"))
      } else {
        Norm2 <- NA
      }
  
      ## Mean value for lrho using transformed function
      tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                   functn=TfnMean,
                   eps=0.0001)
      if (tmp$ifail == 0) {
        lrho.Mean <- tmp$value/Norm2
        cat(paste("Mean of lrho by Transformed function is",lrho.Mean,"\n"))
        MeanVar[[k]][i,"Mean"] <- lrho.Mean
      } 
      ## Mean value for Pc using transformed function
      tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                   functn=TfnMean1,
                   eps=0.0001)
      if (tmp$ifail == 0) {
        lrho.Mean1 <- tmp$value/Norm2
        MeanVar[[k]][i,"MeanPc"] <- lrho.Mean1
        cat(paste("Mean of Pc by Transformed function is",lrho.Mean1,"\n"))
      } 
      ## Mean value for 1-Q using transformed function
      tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                   functn=TfnMean2,
                   eps=0.0001)
      if (tmp$ifail == 0) {
        lrho.Mean2 <- tmp$value/Norm2
        MeanVar[[k]][i,"MeanPa"] <- lrho.Mean2
        cat(paste("Mean of (1-Q) by Transformed function is",lrho.Mean2,"\n"))
      } 

      ## Variance of lrho
      tmp <- adapt(ndim=ndim,lower=X2$low,upper=X2$upp,minpts=Npoints,
                   functn=TfnVar,
                   eps=0.0001,lrho.mean=lrho.Mean)
      if (tmp$ifail == 0) {
        lrho.Var <- tmp$value/Norm2
        cat(paste("Variance of lrho is",lrho.Var,"\n"))
        MeanVar[[k]][i,"Var"] <- lrho.Var
      } 

      ## Calculate the marginal posterior distribution function for lrho.
      ## Start with lrho - 3*sqrt(var), and work backwards until the mass to the
      ## left is < 0.01, then start stepping to the right, up through 0.99
  
      lrho <- lrho.Mean - 3*sqrt(lrho.Var)
      x.save <- NULL
      mass.save <- NULL
      lbound <- X2$low
      ubound <- X2$upp
      Indx <- length(ubound)
      rcount <- 0
      Failure <- FALSE
      cat("Finding the bottom:\n")
      repeat {
        if (rcount > 10) {
          Failure <- TRUE
          break
        }
        ubound[Indx] <- (1 + exp(-lrho))^(-1)
        out <- try(adapt(ndim=ndim,lower=lbound,upper=ubound,
                         minpts=Npoints,functn=TfnFull,
                         eps=0.0001))
        if (!inherits(out,"try-error") && out$ifail == 0) {
          cat(paste(lrho,"  ",out$value/Norm2,"\n"))
          rcount <- 0
          x.save <- c(x.save,lrho)
          mass.save <- c(mass.save,out$value/Norm2)
          if (out$value/Norm2 < 0.005) {
            lrhomin <- lrho
            break
          }
          lrho <- lrho - log(2)
        } else {
          cat("!!!!!!! failure:\n")
          print(out)
          lrho <- lrho + log(2)
          rcount <- rcount + 1
        }
      }
      ## Now find the top end
      lrho <- lrho.Mean + 3*sqrt(lrho.Var)
      rcount <- 0
      Failure <- FALSE
      cat("Finding the top:\n")
      repeat {
        if (rcount > 10) {
          Failure <- TRUE
          break
        }
        ubound[Indx] <- (1 + exp(-lrho))^(-1)
        out <- try(adapt(ndim=ndim,lower=lbound,upper=ubound,
                         minpts=Npoints,functn=TfnFull,
                         eps=0.0001))
        if (!inherits(out,"try-error") && out$ifail == 0) {
          cat(paste(lrho,"  ",out$value/Norm2,"\n"))
          rcount <- 0
          x.save <- c(x.save,lrho)
          mass.save <- c(mass.save,out$value/Norm2)
          if (out$value/Norm2 > 0.995) {
            lrhomax <- lrho
            break
          }
          lrho <- lrho + log(2)
        } else {
          cat("!!!!!!! failure:\n")
          print(out)
          lrho <- lrho - log(2)
          rcount <- rcount + 1
        }
      }
    
      rhosteps <- seq(lrhomin,lrhomax,length=11)
      masssteps <- numeric(length(rhosteps))
    
      ## Stepping Up
      if (!Failure) {
        for (kk in 1:length(rhosteps)) {
          lrho <- rhosteps[kk]
          ubound[Indx] <- (1 + exp(-lrho))^(-1)
          out <- try(adapt(ndim=ndim, lower=lbound,upper=ubound,
                           minpts=Npoints,functn=TfnFull,
                           eps=0.0001))
          if (!inherits(out, "try-error") && out$ifail == 0) {
            cat(paste(lrho, "  ",out$value/Norm2,"\n"))
            masssteps[kk] <- out$value/Norm2
          } else {
            cat("!!!!!! failure in stage 2:\n")
            print(out)
          }
        }
      }
      x.save <- c(x.save,rhosteps)
      mass.save <- c(mass.save,masssteps)
    
      SIndx <- order(x.save)
      x.save <- x.save[SIndx]
      mass.save <- mass.save[SIndx]
      mass.save <- mass.save[!duplicated(x.save)]
      x.save <- x.save[!duplicated(x.save)]
      DistSave[[k]] <- list(X = c(x.save), Y=c(mass.save))
      fspl <- try(interpSpline(x.save,mass.save))
      if (!inherits(fspl,"try-error")) {
        bspl <- try(backSpline(fspl))
      } else {
        bspl <- fspl
      }
      if (!inherits(bspl,"try-error")) {
        qntl <- predict(bspl,c(0.025,0.50,0.975))
        MeanVar[[k]][i,"L025"] <- qntl[[2]][1]
        MeanVar[[k]][i,"Median"] <- qntl[[2]][2]
        MeanVar[[k]][i,"L975"] <- qntl[[2]][3]
      }
   
    }
    AllDists[[i]] <- DistSave
    save("AllDists",file=file.path("Stats","mutacute","Dists.RData"))
    save("MeanVar",file=file.path("Stats","mutacute","MeanVar.RData"))
  }
